using System;
using System.Text;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.ComponentModel;
using System.Globalization;
using System.Reflection;

namespace Andrei.CommonControlsWeb
{
	[ToolboxItem(false)] 
	public class AddRssContainer  :WebControl,INamingContainer
	{
		private AddRSS m_Add;
		public AddRssContainer(AddRSS add)
		{
			m_Add = add;
		}
		public AddRSS RssControl
		{
			get
			{
				return m_Add;
			}
		}
	}
	
	public class AddRssDefaultTemplate : ITemplate,INamingContainer 
	{
		
		
		#region ITemplate Members

		public void InstantiateIn(Control container)
		{

			int iColumns = 4;
			AddRSS a=(container as AddRssContainer).RssControl;

			LiteralControl lcTable = new LiteralControl("<table border='1'><tr align='center'>");			
			container.Controls.Add(lcTable);
			//add original RSS:

			lcTable = new LiteralControl("<td align='center' colspan='"+ iColumns  + "'>");			
			container.Controls.Add(lcTable);
			lcTable = new LiteralControl(a.Url + "&nbsp;" + a.OriginalRSS);
			container.Controls.Add(lcTable);
			lcTable = new LiteralControl("</td>");			
			container.Controls.Add(lcTable);
			lcTable = new LiteralControl("</tr>");			
			container.Controls.Add(lcTable);
			int iRSS = 0;
			//to ensure that we do not miss any one property
			// we use reflection with defined name :"RSSDisplay"
			//when we find this property we should call

			foreach(PropertyInfo m in a.GetType().GetProperties())
			{
				
				//standard name for property that can be used to display RSS reader
				if(m.Name.IndexOf("RSSDisplay") == -1)
					continue;

				iRSS++;
				LiteralControl lc = new LiteralControl("<td align='center'>");
				container.Controls.Add(lc);
				
				lc = new LiteralControl(m.GetValue(a,null).ToString());
				container.Controls.Add(lc);
				
				lc = new LiteralControl("</td>");
				container.Controls.Add(lc);
				if (iRSS % iColumns == 0)
				{
					container.Controls.Add(new LiteralControl("</tr><tr>"));
				}
				
			}

			lcTable = new LiteralControl("</tr></table>");
			container.Controls.Add(lcTable);
		}

		#endregion
	}
}
